//+------------------------------------------------------------------+
//|                                   Trailing Stop Open Trades EA_ea|
//|                                                                ro|
//|                                                                  |
//+------------------------------------------------------------------+

extern int MagicNumber=777;
extern double Lots =0.01;
extern double StopLoss=0;
extern double TakeProfit=25;
extern int TrailingStop=0;
extern int Slippage=3;
extern double Pips_Amount =3;
extern int max_trades_day=1;
extern int gmt_offset=0;
extern bool sunday=true;
extern int sendmail=1;

int count;
double point;

//+------------------------------------------------------------------+
//    expert start function
//+------------------------------------------------------------------+
int start()
{
  int    counted_bars=IndicatorCounted();
  double MyPoint=Point;
  if(Digits==3 || Digits==5) MyPoint=Point*10;
  if (Digits==1)point=0.1;
   if (Digits==2)point=0.01;
   if (Digits==3)point=0.01;
   if (Digits==4)point=0.0001;
   if (Digits==5)point=0.0001;
   if (Bars<100)return;
  
  double TheStopLoss=0;
  double TheTakeProfit=0;
  int i,j=0;
  bool nobuy=false,nosell=false;
  
  
  if( (DayOfWeek()==1 && Hour()<3) || (DayOfWeek()==5 && Hour()>17) ) return(0);
 
  
  for(i=0;i<OrdersHistoryTotal();i++) 
  {
     OrderSelect(i, SELECT_BY_POS, MODE_HISTORY);
     if(OrderMagicNumber()==MagicNumber && TimeDay(OrderOpenTime()) == TimeDay(TimeCurrent()))
     {
        j=j+1;
        if(j>=max_trades_day) return(0);
     }
  }

  for(i=OrdersHistoryTotal()-1;i>=0;i--) 
  {
     OrderSelect(i, SELECT_BY_POS, MODE_HISTORY);
     if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
     {
        if(Year()==TimeYear(OrderOpenTime()) && DayOfYear()==TimeDayOfYear(OrderOpenTime()) && Hour()==TimeHour(OrderOpenTime()) )return(0);
     }
  }
  
   for(i=0;i<OrdersHistoryTotal();i++) 
   {
      OrderSelect(i, SELECT_BY_POS, MODE_HISTORY);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) 
      {
         if(Period()==1 && TimeMinute(OrderOpenTime())== Minute() && TimeHour(OrderOpenTime())==Hour() && TimeDayOfYear(OrderOpenTime())==DayOfYear() && TimeYear(OrderOpenTime())==Year()) return(0);
         if(Period()==5 && Minute()-5<TimeMinute(OrderOpenTime()) && TimeHour(OrderOpenTime())==Hour() && TimeDayOfYear(OrderOpenTime())==DayOfYear() && TimeYear(OrderOpenTime())==Year()) return(0);
         if(Period()==15 && Minute()-15<TimeMinute(OrderOpenTime()) && TimeHour(OrderOpenTime())==Hour() && TimeDayOfYear(OrderOpenTime())==DayOfYear() && TimeYear(OrderOpenTime())==Year()) return(0);
         if(Period()==60 && TimeHour(OrderOpenTime())==Hour() && TimeDayOfYear(OrderOpenTime())==DayOfYear() && TimeYear(OrderOpenTime())==Year()) return(0);
         if(Period()==240 && Hour()-4<TimeHour(OrderOpenTime()) && TimeDayOfYear(OrderOpenTime())==DayOfYear() && TimeYear(OrderOpenTime())==Year()) return(0);
         if(Period()==1440 && TimeDayOfYear(OrderOpenTime())==DayOfYear() && TimeYear(OrderOpenTime())==Year()) return(0);
         if(Period()==10080 && DayOfYear()-7<TimeDayOfYear(OrderOpenTime()) && TimeYear(OrderOpenTime())==Year()) return(0);
         if(Period()==40320 && TimeMonth(OrderOpenTime())==Month() && TimeYear(OrderOpenTime())==Year()) return(0);
      }
   }
    
  if( TotalOrdersCount()<1 ) 
  {
     int result=0;
     
   string tf,othertftext,text;
    
   
   static datetime TimeStamp, TimeStamp2;//  Open[0]>Close[1] (count!=iBarShift(NULL,0,0 
   
     
     
   if ( ((Close[0]>Open[0] && (Bid>=Open[0]+Pips_Amount*point))))//Here is your open Buy rule
     {
        result=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,0,0,"Trailing Stop Open Trades EA",MagicNumber,0,Blue);
        if(result>0)
        {
         TheStopLoss=0;
         TheTakeProfit=0;
         if(TakeProfit>0) TheTakeProfit=Ask+TakeProfit*MyPoint;
         if(StopLoss>0) TheStopLoss=Ask-StopLoss*MyPoint;
         OrderSelect(result,SELECT_BY_TICKET);
         OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(TheStopLoss,Digits),NormalizeDouble(TheTakeProfit,Digits),0,Green);
        }
        if(result<0)
        {
         Print("OrderSend failed with error #",GetLastError());
         return(0);
        }
          if(Period()==1) tf="M1";
          if(Period()==5) tf="M5";
          if(Period()==15) tf="M15";
          if(Period()==60) tf="H1";
          if(Period()==240) tf="H4";
          if(Period()==1440) tf="D1";
          if(Period()==10080) tf="W1";
          if(Period()==40320) tf="MN";
          text = StringConcatenate(" Trailing Stop Order  ", tf," ",Symbol()); 
          if(sendmail==1) SendMail("[BUY] Trade placed at ", text);
          Alert("[BUY] Trade placed at ",tf," ",Symbol());  // Open[0]<Close[1]   count!=iBarShift(NULL,0,0
        return(0);
     }
     if ((Close[0]<Open[0] && (Bid<=Open[0]-Pips_Amount*point))) //Here is your open Sell rule
     {
        result=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,0,0,"Trailing Stop Open Trades EA",MagicNumber,0,Red);
        if(result>0)
        {
         TheStopLoss=0;
         TheTakeProfit=0;
         if(TakeProfit>0) TheTakeProfit=Bid-TakeProfit*MyPoint;
         if(StopLoss>0) TheStopLoss=Bid+StopLoss*MyPoint;
         OrderSelect(result,SELECT_BY_TICKET);
         OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(TheStopLoss,Digits),NormalizeDouble(TheTakeProfit,Digits),0,Green);
        }
        if(result<0)
        {
         Print("OrderSend failed with error #",GetLastError());
         return(0);
        }
          if(Period()==1) tf="M1";
          if(Period()==5) tf="M5";
          if(Period()==15) tf="M15";
          if(Period()==60) tf="H1";
          if(Period()==240) tf="H4";
          if(Period()==1440) tf="D1";
          if(Period()==10080) tf="W1";
          if(Period()==40320) tf="MN";
          text = StringConcatenate(" Trailing Stop Order  ", tf," ",Symbol()); 
          if(sendmail==1) SendMail("[SELL] Trade placed at ", text);
          Alert("[SELL] Trade placed at ",tf," ",Symbol());
        return(0);
     }
  }
  
  for(int cnt=0;cnt<OrdersTotal();cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   
         OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber 
         )  
        {
         if(OrderType()==OP_BUY)  
           {
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>MyPoint*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-MyPoint*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TrailingStop*MyPoint,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else 
           {
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(MyPoint*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+MyPoint*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+MyPoint*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
}

int TotalOrdersCount()
{
  int result=0;
  for(int i=0;i<OrdersTotal();i++)
  {
     OrderSelect(i,SELECT_BY_POS ,MODE_TRADES);
     if (OrderMagicNumber()==MagicNumber) result++;
     if (OrderSymbol()==Symbol()) return(1000);
   }
  return (result);
}